'***************************************************************'
'PROGRAMMA PER CONTROLLO FRESA XYZ
'PORTA PARALELA LPT1
'IMPOSTARE MOTORI FUNZIONAMENTO 1/2 PASO
'PLOTA FILES *.HPGL E FORMATO *.XY
'***************************************************************'


'<<<<<<<<<<<<<
pinizio:                     'inizializza il programma
'<<<<<<<<<<<<<
CLEAR
CLS


'***** impostazioni parametri fresa *****

OPEN "fresa.cfg" FOR INPUT AS #5

LINE INPUT #5, ax1$
LINE INPUT #5, ax2$
LINE INPUT #5, ax3$
LINE INPUT #5, ax4$
LINE INPUT #5, ax5$

CLOSE #5


passipergiro = VAL(ax1$)
passovite = VAL(ax2$)
passovitez = VAL(ax3$)
scale = VAL(ax4$)
velpc = VAL(ax5$)


'passipergiro = 200
'passovite = 4
'passovitez = 8
'scale = 20              'escala disegno in video numeros grandes disegnos chicos
'velpc = 100             'velocita pc 100 per 486 dx33 magiore per + veloci

escalaf = (passipergiro / passovite) / 40   'escala assi xy
escalaz = passipergiro / passovitez  'escala asse Z
escalaw = passipergiro / passovite


REM  maxrighe% = 1000        'anche 2000 , dipende dal compilatore
DIM RIGA$(maxrighe%)         'vettore delle righe del file di help

MAXCOLO% = 5                 'dimensionamento vettori voci menu
DIM VoceMenu$(MAXCOLO%, 16)  'vettore bidimensionale delle voci del menu
DIM Commento$(MAXCOLO%, 16)  'vettore bidimensionale dei commenti associati ad ogni voce
ON ERROR GOTO pGestErrori
'---------- costanti:
C0% = 0                      'colore di fondo e nel reverse
C3% = 3                      'colore riquadro
c7% = 7                      'colore default
c12% = 12                    'colore usato in un titolo
c14% = 14                    'colore usato in un titolo
c15% = 15                    'colore usati in reverse
'------
blar$ = STRING$(79, 196)     '79 caratteri equiv. ad una linea
blab$ = STRING$(79, 32)      '79 caratteri equiv. a una riga vuota(cancella)
'----------- valori iniziali
Xatt% = 1                    'colonna attuale
XPREC% = 1                   'colonna precedente
Yatt% = 1                    'riga    attuale
Yprec% = 1                   'riga    precedente
tit% = 1                     'tilolo, (uno solo)
'------------
GOSUB pCaricaVociMenu        'carica le voci del menu
GOSUB pGeneraMenu            'genera il menu
GOTO pGestione               'gestione scelte


'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
' gestione scelte
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

'---------
pGeneraMenu:
'--------
 CLS : COLOR c15%, C0%
 LOCATE 2, 1: PRINT blar$
 GOSUB pTitolo               'stampa il titolo
 GOSUB pRiquadroVoci         'genera il riquadro delle voci
 GOSUB pRigeneraVoci         'stampa le voci
 GOSUB pControlRange         'controlla il range della selezione
 GOSUB pVoceReverse          'evidenzia in reverse l'utima voce
RETURN

'///////////////////////////////
pGestione:
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

 k$ = "": kk% = 0: lu% = 0:
 k$ = INKEY$: lu% = LEN(k$)
 '----- tasto sel --------------
  IF lu% > 0 THEN
    IF lu% = 1 THEN kk% = ASC(k$)
    IF lu% = 2 THEN kk% = ASC(RIGHT$(k$, 1))
     SELECT CASE kk%
      CASE 13: GOSUB pInvio                 'conferma selezione
      CASE 27: GOSUB pConfUscita            'uscita previa conferma
      CASE 9: Xatt% = Xatt% + 1: GOSUB pControlRange
      CASE 59: GOSUB pinfo: GOTO pinizio
      CASE 77: Xatt% = Xatt% + 1: GOSUB pControlRange
      CASE 75: Xatt% = Xatt% - 1: GOSUB pControlRange
      CASE 80, 81: Yatt% = Yatt% + 1: GOSUB pControlRange
      CASE 72, 73: Yatt% = Yatt% - 1: GOSUB pControlRange
      CASE 71: Yatt% = 1: Xatt% = 1: GOSUB pControlRange
      CASE 79: Yatt% = MaxVoceCol%(nColMenu%): Xatt% = nColMenu%: GOSUB pControlRange
     END SELECT
   END IF
GOTO pGestione

'---------
pInvio:                             'E stato premuto il tasto Invio
'---------
 PROESE% = Xatt% * 100 + Yatt%      'algoritmo per il calcolo del numero
				    'corrispondente alla selezione
 XPREC% = Xatt%: Yprec% = Yatt%      'memorizzazione della scelta
 GOSUB pEsegue                       'esegue l'operazione
 GOSUB pGeneraMenu                   'rigenera il menu
RETURN


'------------
pControlRange:   'controlla la validita' del range
'------------
 IF Xatt% > nColMenu% THEN Xatt% = 1
 IF Xatt% < 1 THEN Xatt% = nColMenu%
 IF Yatt% < 1 THEN Yatt% = MaxVoceCol%(Xatt%)
 IF Yatt% > MaxVoceCol%(Xatt%) THEN Yatt% = 1
 IF (Yprec% <> Yatt%) OR (Xatt% <> XPREC%) THEN GOSUB pVoceReverse
 Yprec% = Yatt%: XPREC% = Xatt%
RETURN


'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


'---------------------------
pTitolo:                  'gestione dei titoli (1..3)
'---------------------------
 LOCATE 4, 1
 PRINT " NN   N   CCCCC   DDDDD   RRRRR   II II     II        "
 PRINT " N N  N  C        D    D  R    R  II II     II        "
 PRINT " N  N N  C        D    D  RRRRR   II II     II        "
 PRINT " N   NN  C        D    D  R   R   II II     II        "
 PRINT " N    N   CCCCC   DDDDD   R    R  II IIIIII IIIIII    "
RETURN

'^^^^^^^^^^^^^^^^^^^^^^^^^^^^



'----------
pRiquadroVoci:
'----------
 COLOR C0%, C3%
 LOCATE 9, 3: PRINT "" + STRING$(73, "") + ""
  FOR I% = 1 TO 10
   LOCATE 9 + I%, 3: PRINT "" + STRING$(73, " ") + ""
  NEXT I%
 LOCATE 20, 3: PRINT "" + STRING$(73, "") + ""
RETURN


'----------
pRigeneraVoci:
'----------
 COLOR c15%, C3%                     ' stampa i titoli del menu
  FOR j% = 1 TO nColMenu%
   LOCATE dy% - 1, dx% + XPOSCOL%(j%)
   PRINT VoceMenu$(j%, 0)
  NEXT j%

  COLOR C0%, C3%                        ' stampa le voci menu
  FOR j% = 1 TO nColMenu%
   FOR I% = 1 TO MaxVoceCol%(j%)
    LOCATE I% + dy%, dx% + XPOSCOL%(j%)
    PRINT VoceMenu$(j%, I%)
   NEXT I%
  NEXT j%
 GOSUB pVoceReverse
RETURN

'----------
pVoceReverse: 'stampa in reverse
'----------
 COLOR C0%, C3%                              'ripristina colore orig. voce precedente
 LOCATE Yprec% + dy%, dx% + XPOSCOL%(XPREC%)
 PRINT VoceMenu$(XPREC%, Yprec%)

 COLOR c15%, C0%                             'evidenzia in reverse la voce attuale
 LOCATE Yatt% + dy%, dx% + XPOSCOL%(Xatt%)
 PRINT VoceMenu$(Xatt%, Yatt%)

 LOCATE 1, 1: PRINT blab$                    'cancella la prima riga
 LOCATE 1, 1: PRINT Commento$(Xatt%, Yatt%)  'stampa il commento alla voce
RETURN

'fine gestione scelte
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


'||||||||||||||||||||||||||||||||||||||||||||||||||||||||
' gestione titoli
'||||||||||||||||||||||||||||||||||||||||||||||||||||||||


'||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
' INIZIO SERIE PROCEDURE DI USO GENERICO
'||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'------------
pGestErrori:     'gestione degli errori
'------------
 SELECT CASE ERR
   CASE 5:   messag$ = "Controllare la sintassi"
   CASE 6:   messag$ = "Overflow"
   CASE 7:   messag$ = "Memoria esaurita"
   CASE 11:  messag$ = "Divisione per zero"
   CASE 14:  messag$ = "Spazio per le stringhe easurito"
   CASE 16:  messag$ = "Formula troppo complessa"
   CASE 25:  messag$ = "Errore di periferica"
   CASE 27:  messag$ = "Carta esaurita"
   CASE 51:  messag$ = "Errore interno"
   CASE 52:  messag$ = "Nome di file errato"
   CASE 53:  messag$ = "File non trovato"
   CASE 55:  messag$ = "File gia' aperto"
   CASE 57:  messag$ = "Errore I/O su periferica"
   CASE 61:  messag$ = "Disco pieno"
   CASE 62:  messag$ = "Input dati oltre la fine del file..Troncare il file"
   CASE 64:  messag$ = "Nome file errato"
   CASE 67:  messag$ = "Troppi file"
   CASE 68:  messag$ = "Periferica non disponibile"
   CASE 70:  messag$ = "Disco protetto"
   CASE 71:  messag$ = "Disco non pronto"
   CASE 76:  messag$ = "Percorso non trovato"
  CASE 201:  messag$ = "Stack esaurito"
 END SELECT
 GOSUB pStampaMessaggio: GOSUB pPausa
 RESUME pinizio

'-------------
pConfUscita:
'-------------
 messag$ = " Q .. Per confermare l'uscita":
 GOSUB pStampaMessaggio
 LOCATE 1, 20: GOSUB pPausa
 IF q$ = "Q" OR q$ = "q" THEN COLOR c7%, C0%: CLS : SYSTEM
RETURN

'--------------
pNoPronto:    'Trappola per procedure non ancora preparate
'-------------
 messag$ = " Procedura non disponibile .. Premere un tasto per continuare."
 GOSUB pStampaMessaggio: GOSUB pPausa
RETURN

'--------
pPausa:  'crea una pausa
'--------
 q$ = INPUT$(1)
RETURN

'--------------
pStampaMessaggio:
'-------------
 LOCATE 1, 1: PRINT blab$:  LOCATE 1, 1: PRINT messag$
RETURN

'------------
pDos:
'------------
 LOCATE 1, 1: LINE INPUT "Digitare il comando Dos :  ", ComDos$
 IF ComDos$ = "" THEN LOCATE 1, 1: PRINT blab$: GOTO pGestione
RETURN

'------------
pExecDos:
'------------
 CLS
 SHELL ComDos$
RETURN

'------------
pinfo:
'------------
 CLS
 LOCATE 1, 1:  PRINT " Informazioni sul modulo "
 PRINT blar$
 PRINT " Modulo realizzato per LEVEL TRENTO "
 GOSUB pPausa
RETURN

' fine procedure di uso generico
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^



'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
'  ZONA IN CUI SONO POSSIBILI MODIFICHE
'|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

'--------------
pCaricaVociMenu:   'carica le voci del menu
'--------------


 dy% = 11                     'riga    iniziale delle voci del menu
 dx% = 7                      'colonna uniziale delle voci del menu

 nColMenu% = 3     'numero colonne del menu
 DeltaXcol% = 24   'spazio tra le colonne
 '
 VoceMenu$(1, 0) = " GENERALE       "  'titolo
 VoceMenu$(1, 1) = " Info           ": Commento$(1, 1) = "  Informazioni dul modulo"
 VoceMenu$(1, 2) = " Comando Dos..  ": Commento$(1, 2) = "  Attiva un comando Dos"
 VoceMenu$(1, 3) = " DOS Shell      ": Commento$(1, 3) = "  Riporta al sistema operativo .. Si ritorna, digitando da Dos, EXIT"
 VoceMenu$(1, 4) = " No Pronto      ": Commento$(1, 4) = "No pronto  "
 VoceMenu$(1, 5) = " Fine           ": Commento$(1, 5) = "  Uscita dal programma .. Tasto rapido ESC"
 MaxVoceCol%(1) = 5                     'numero voci del 1 menu
 '
 VoceMenu$(2, 0) = " MODULI "
 VoceMenu$(2, 1) = " VISUALIZA *.hpg": Commento$(2, 1) = "  Programma per controlare NCDRILL"
 VoceMenu$(2, 2) = " hpg2plt simple ": Commento$(2, 2) = "  Conversione file Smart padmaster DXF 2.0 - XY"
 VoceMenu$(2, 3) = " CONTROLLO FRESA": Commento$(2, 3) = "  Attiva l'applicazione n. 3 "
 VoceMenu$(2, 4) = " CONV: WENSUD_XY": Commento$(2, 4) = "  Attiva l'applicazione n. 4 "
 VoceMenu$(2, 5) = " PLOT FILE hpg  ": Commento$(2, 5) = "  Attiva l'applicazione n. 5 "
 MaxVoceCol%(2) = 5
 '
 VoceMenu$(3, 0) = " UTILITY "
 VoceMenu$(3, 1) = " Ord.alfabetico ": Commento$(3, 1) = "  Visualizza i file della directory corrente, in ordine alfabetico."
 VoceMenu$(3, 2) = " Ord.data       ": Commento$(3, 2) = "  Visualizza i file della directory corrente, in ordine di data."
 VoceMenu$(3, 3) = " Ord.per colonne": Commento$(3, 3) = "  Visualizza i file della directory corrente, per colonne."
 VoceMenu$(3, 4) = " Memoria        ": Commento$(3, 4) = "  Visualizza la memoria disponibile"
 MaxVoceCol%(3) = 4

 '
 FOR I% = 1 TO nColMenu%
  XPOSCOL%(I%) = (I% - 1) * DeltaXcol%  'posizione colonne del menu
 NEXT I%

 RETURN

'-----------------
pEsegue:    'esegue  i comandi relativi alle scelte
'-----------------
 COLOR c7%
 SELECT CASE PROESE%
  CASE 101: GOSUB pinfo
  CASE 102: GOSUB pDos: GOSUB pExecDos: GOSUB pPausa
  CASE 103: ComDos$ = "": GOSUB pExecDos:
  CASE 104: GOSUB pNoPronto
  CASE 105: GOSUB pConfUscita '>>>>>>>>>>
  '---
  CASE 201: GOSUB VISHPG: GOTO pinizio   'da attivare
  CASE 202: GOSUB hpg2plt: GOTO pinizio  'da attivare
  CASE 203: GOSUB FRESAR: GOTO pinizio
  CASE 204: GOSUB WENSUD: GOTO pinizio
  CASE 205: GOSUB plothpg: GOTO pinizio
  '---
  CASE 301: ComDos$ = "DIR /ON/P": GOSUB pExecDos: GOSUB pPausa
  CASE 302: ComDos$ = "DIR /OD/P": GOSUB pExecDos: GOSUB pPausa
  CASE 303: ComDos$ = "DIR /W/P": GOSUB pExecDos:  GOSUB pPausa
  CASE 304: ComDos$ = "MEM /P": GOSUB pExecDos: GOSUB pPausa
  '---
  CASE ELSE: GOSUB pNoPronto
 END SELECT
RETURN

'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
'fine zona modifiche

'------------------------------------------------------------



VISHPG:

	CLS

SCREEN 12

INPUT " Entrare nome File *.hpg , *.plt , * hgl  = "; F$
IF F$ = "" THEN END
OPEN F$ FOR BINARY AS #1

xold = 0
yold = 0

DO WHILE NOT EOF(1)
 
	a$ = INPUT$(1, 1)                                   'read file 1 character
	B$ = B$ + a$
 
IF a$ = ";" THEN
	 
	cmd$ = LEFT$(B$, 2)
	IF cmd$ = "PU" THEN mode$ = "M"     'Move
	IF cmd$ = "PD" THEN mode$ = "D"     'Draw
	 
	l = LEN(B$)
	IF l > 3 THEN
		IF cmd$ = "PA" OR cmd$ = "PU" OR cmd$ = "PD" THEN
			comma = INSTR(B$, ",")
	 
			x$ = MID$(B$, 3, comma - 3)
			x = VAL(x$)
			xscreen = VAL(x$) / scale
	 
			Y$ = MID$(B$, comma + 1, l - LEN(x$) - 4)
			Y = VAL(Y$)
			yscreen = VAL(Y$) / scale
	 
			IF mode$ = "M" THEN PSET (5 + xscreen, 475 - yscreen), 0
			IF mode$ = "D" THEN LINE -(5 + xscreen, 475 - yscreen), 15
		    
		END IF
	END IF
	B$ = ""
END IF


LOOP



CLOSE
	  DO WHILE INKEY$ = ""
	  LOOP
SCREEN 0


RETURN
'-------------------------------------------------------
hpg2plt:
	    CLS
	    LOCATE 10, 1

	    INPUT "entrare nome file *.hpg senza estensione = "; nomefile$
	    ComDos$ = "hpglexp" + " " + nomefile$ + ".hpg " + nomefile$ + ".plt"
	    CLS
	    SHELL ComDos$

	    DO WHILE INKEY$ = ""
	    LOOP
RETURN

'-------------------------------------------------------
plothpg:

FFRESA = 1
CLS
DEFINT I
KEY OFF
'****  zona impostazione velocita e acelerazione ****

INPUT " velocita min,media,max (1,2,3)  ="; veloci
IF veloci = 1 THEN
      accz = INT(12 * velpc)                  'velocita in z
      maxaccxy = INT(4.5 * velpc)              'max velocita xy
      minaccxy = INT(2.25 * velpc)           'accelerazione xy
END IF
IF veloci = 2 THEN
      accz = INT(12 * velpc)                  'velocita in z
      maxaccxy = INT(3 * velpc)            'max velocita xy
      minaccxy = INT(1.5 * velpc)            'accelerazione xy
END IF
IF veloci = 3 THEN
      accz = INT(12 * velpc)              'velocita in z
      maxaccxy = INT(1.5 * velpc)           'max velocita xy
      minaccxy = INT(.75 * velpc)         'accelerazione xy
END IF

INPUT " corsa su e giu in mm Z  ="; moviz
moviz = moviz * escalaz


	CLS

SCREEN 12


flagm = 1

OUT (&H378), 0

INPUT " Entrare nome File *.hpg , *.plt , *.hgl  =  "; F$
IF F$ = "" THEN END
OPEN F$ FOR BINARY AS #1

xold = 0
yold = 0

DO WHILE NOT EOF(1)
  
	a$ = INPUT$(1, 1)                                   'read file 1 character
	B$ = B$ + a$
  
IF a$ = ";" THEN
	  
	cmd$ = LEFT$(B$, 2)
	IF cmd$ = "PU" THEN mode$ = "M"     'Move
	IF cmd$ = "PD" THEN mode$ = "D"     'Draw
	  
	l = LEN(B$)
	IF l > 3 THEN
		IF cmd$ = "PA" OR cmd$ = "PU" OR cmd$ = "PD" THEN
			comma = INSTR(B$, ",")
	  
			x$ = MID$(B$, 3, comma - 3)
			x = VAL(x$)
			xscreen = VAL(x$) / scale
	  
			Y$ = MID$(B$, comma + 1, l - LEN(x$) - 4)
			Y = VAL(Y$)
			yscreen = VAL(Y$) / scale
	  
			IF mode$ = "M" THEN PSET (5 + xscreen, 475 - yscreen), 0
			IF mode$ = "D" THEN LINE -(5 + xscreen, 475 - yscreen), 15
		       

			stepz = 128
			zdirection = 64

			IF mode$ = "M" AND flagm = 0 THEN
			  flagm = 1
			  FOR z = 1 TO moviz
			      OUT (&H378), (stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), 0
			      FOR t = 1 TO 1: NEXT t
			      FOR acc = 1 TO accz
			      NEXT acc
			   NEXT z
			END IF

			IF mode$ = "D" AND flagm = 1 THEN
			  flagm = 0
			  FOR z = 1 TO moviz
			      OUT (&H378), (zdirection + stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), zdirection
			      FOR acc = 1 TO accz
			      NEXT acc
			   NEXT z
			END IF
			

		END IF
	END IF
	B$ = ""
END IF

	xnew = INT(x * escalaf)
	ynew = INT(Y * escalaf)
  
       
       
	IF xnew < xold THEN xi = xold - xnew ELSE xi = xnew - xold   'this
	IF ynew < yold THEN yi = yold - ynew ELSE yi = ynew - yold   'part
								 'of
	IF xi <= 0 THEN xi = yi                                      'the
	IF yi <= 0 THEN yi = xi                                      'code
								 'is
	IF xi > yi THEN                                              'for
	add2x = 1                                                'lines
	add2y = yi / xi                                          'under
	END IF                                                       'an
								 'angle
	IF yi > xi THEN                                              'other wise
	add2x = xi / yi                                          'the
	add2y = 1                                                'plotter
	END IF                                                       'would
								 'draw
	IF yi = xi THEN                                              'lines
	add2x = 1                                                'other
	add2y = 1                                                'then straight
	END IF                                                       'or 45 degree
								 'lines wrong


 IF xnew > xold THEN xdirection = 4 ELSE xdirection = 0  'data 6 -> pin 7
 IF ynew < yold THEN ydirection = 16 ELSE ydirection = 0  'data 7 -> pin 8

 IF xnew = xold THEN xdirection = oldxdirection
 IF ynew = yold THEN ydirection = oldydirection

 oldxdirection = xdirection
 oldydirection = ydirection


acceleratie = minaccxy                       'stepdelay


stap1:
 
  IF INKEY$ = CHR$(27) THEN GOTO theend          'if <escape> is pressed then end program

  IF CINT(u) < x * escalaf THEN u = u + add2x
  IF CINT(u) > x * escalaf THEN u = u - add2x
  IF CINT(v) < Y * escalaf THEN v = v + add2y
  IF CINT(v) > Y * escalaf THEN v = v - add2y

ValeuX = CINT(u) MOD 8          'used for uln2803 & 5804
ValeuY = CINT(v) MOD 8          'see next lines why for 5804
	
IF ValeuX <> StoreValeuX THEN stepx = 8 ELSE stepx = 0      'data 1 -> pin 2
IF ValeuY <> StoreValeuY THEN stepy = 32 ELSE stepy = 0      'data 2 -> pin 3

StoreValeuX = ValeuX
StoreValeuY = ValeuY
	      
	   OUT (&H378), (xdirection + stepx + ydirection + stepy)
	   FOR t = 1 TO 1: NEXT t
	   OUT (&H378), (xdirection + ydirection)
 
  xi = xi - add2x
  yi = yi - add2y

	IF xi > yi THEN
		IF xi < maxaccxy THEN acceleratie = acceleratie + 2.5
	ELSE IF yi < maxaccxy THEN acceleratie = acceleratie + 2.5
	END IF
       
	 IF acceleratie > minaccxy THEN acceleratie = minaccxy
	 IF acceleratie < maxaccxy THEN acceleratie = maxaccxy
       
	 FOR N = 1 TO acceleratie: NEXT N
	 acceleratie = acceleratie - 1.5
	
	 IF xnew <> CINT(u) OR ynew <> CINT(v) THEN GOTO stap1
	
xold = INT(x * escalaf)
yold = INT(Y * escalaf)

LOOP

theend:

OUT (&H378), 0
OUT (&H378 + 2), 0 XOR 11


CLOSE
	  DO WHILE INKEY$ = ""
	  LOOP
SCREEN 0


RETURN


'-----------------------------------------------------------


'-------------------------------------------------------------

WENSUD:
    SCREEN 12


	  PRINT "ENTRARE NOME FILE (wensud) = ";
	  INPUT NOMBF$
	  PRINT "ENTRARE NOME FILE (fresa ) = ";
	  INPUT NOMBF2$
	  PRINT "ESCALA DISEGNO";
	  INPUT escala
	  CLS
	  OPEN NOMBF2$ FOR OUTPUT AS #2
	  OPEN NOMBF$ FOR INPUT AS #1
	  x = 0
	  Y = 0
	  z = 0
	  
	  XGRAF = 320 / escala
	  YGRAF = 240 / escala
	  XGRAFN = 320 / escala
	  YGRAFN = 240 / escala

		   PRINT #2, STR$(Y)
		   PRINT #2, STR$(x)
		   PRINT #2, STR$(z)

	  DO WHILE NOT EOF(1)
	    LINE INPUT #1, B$
	    
	      IF INSTR(1, B$, "N") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  Y = Y + NR
		  YGRAFN = YGRAF - NR
	      END IF
	      IF INSTR(1, B$, "S") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  Y = Y - NR
		  YGRAFN = YGRAF + NR
	      END IF
	      IF INSTR(1, B$, "W") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  x = x - NR
		  XGRAFN = XGRAF - NR
	      END IF
	      IF INSTR(1, B$, "E") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  x = x + NR
		  XGRAFN = XGRAF + NR
	      END IF
	      IF INSTR(1, B$, "U") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  z = z - NR
		  BAJA = 0
	      END IF
	      IF INSTR(1, B$, "D") = 1 THEN
		  l = LEN(B$)
		  NR$ = MID$(B$, 2, l - 1)
		  NR = VAL(NR$)
		  z = z + NR
		  BAJA = 1
	      END IF
		  
		 IF BAJA = 1 THEN
		   
		   LINE (XGRAF * escala, YGRAF * escala)-(XGRAFN * escala, YGRAFN * escala)
		 END IF
		   XGRAF = XGRAFN
		   YGRAF = YGRAFN

		   
		   PRINT #2, STR$(Y)
		   PRINT #2, STR$(x)
		   PRINT #2, STR$(z)
		   
	  REM         PRINT STR$(X)
	  REM         PRINT STR$(Y)
	  REM         PRINT STR$(Z); "*"

		 
     LOOP
    
    
	  WHILE INKEY$ = ""
	  WEND



	  CLOSE
	  SCREEN 0


       RETURN

'-------------------------------------------------------------

'--------------------------------------------------------------

FRESAR:
FFRESA = 1
CLS
DEFINT I
KEY OFF

INPUT " velocita min,media,max (1,2,3)  ="; veloci

IF veloci = 1 THEN
      maxaccxy = INT(6 * velpc)             'max velocita xy 100 per vetronite , 2 normale
      minaccxy = INT(.5 * velpc)             'accelerazione xy 50 per vetronite , 20 normale
END IF
IF veloci = 2 THEN
      maxaccxy = INT(4 * velpc)             'max velocita xy 100 per vetronite , 2 normale
      minaccxy = INT(.5 * velpc)           'accelerazione xy 50 per vetronite , 20 normale
END IF
IF veloci = 3 THEN
      maxaccxy = INT(2 * velpc)             'max velocita xy 100 per vetronite , 2 normale
      minaccxy = INT(.5 * velpc)          'accelerazione xy 50 per vetronite , 20 normale
END IF

'****  impostazione velocita e acelerazione Z  ****

IACELD = INT(.2 * velpc)     'ACELERAZIONE IN Z
IMAXVELD = INT(12 * velpc)    'VELOCITA MAX IN Z

'**** fine impostazioni ****

	CLS


	OUT (&H378), 0
       
	CLS
	LOCATE 10, 10
	PRINT "ENTRARE NOME FILE (*.XY) = ";
	INPUT NOMBF2$
	yold = 0
	xold = 0
	SCREEN 12
       

	CLS
	   
      
	OPEN NOMBF2$ FOR INPUT AS #2
	  
	    LINE INPUT #2, E$               'CARICA PRIMO FORO
	    LINE INPUT #2, F$
	    LINE INPUT #2, g$
	    E = INT((VAL(E$)) * escalaw)
	    F = INT((VAL(F$)) * escalaw)
	    g = (VAL(g$))
	    EINIZ = E
	    FINIZ = F
	    GINIZ = g
	    yabs = E
	    xabs = F
	    zabs = g
	   
     
     DO WHILE NOT EOF(2)                     'FORI SUCESIVI
       
	    LINE INPUT #2, E$
	    LINE INPUT #2, F$
	    LINE INPUT #2, g$
	    E = INT((VAL(E$)) * escalaw)
	    F = INT((VAL(F$)) * escalaw)
	    g = (VAL(g$))
	  
	    YACT = SQR((yabs - E) * (yabs - E))
	    XACT = SQR((xabs - F) * (xabs - F))
	    ZACT = SQR((zabs - g) * (zabs - g))

       
      
	    IF g < zabs THEN
	       IAVANTI = ZACT + 1
	       GOSUB sU
	       zabs = zabs - ZACT
	    END IF
	    IF g > zabs THEN
	       IAVANTI = ZACT
	       GOSUB giu
	       zabs = zabs + ZACT
	     END IF
	   
	   
	    IF g < zabs THEN
	       zabs = zabs - ZACT
	    END IF
	    IF g > zabs THEN
	       zabs = zabs + ZACT
	     END IF
    

	    IF E < yabs THEN
	       yabs = yabs - YACT
	    END IF
	    IF E > yabs THEN
	       yabs = yabs + YACT
	     END IF
	
	    IF F < xabs THEN
	       xabs = xabs - XACT
	    END IF
	    IF F > xabs THEN
	       xabs = xabs + XACT
	     END IF
	   
	    x = yabs
	    Y = xabs

	    xscreen = x / scale
	    yscreen = Y / scale
	    LINE (5 + yold / scale, 240 - xold / scale)-(5 + yscreen, 240 - xscreen)



	    xnew = x
	    ynew = Y

       
       
       
	IF xnew < xold THEN xi = xold - xnew ELSE xi = xnew - xold   'this
	IF ynew < yold THEN yi = yold - ynew ELSE yi = ynew - yold   'part
								 'of
	IF xi <= 0 THEN xi = yi                                      'the
	IF yi <= 0 THEN yi = xi                                      'code
								 'is
	IF xi > yi THEN                                              'for
	    add2x = 1                                                'lines
	    add2y = yi / xi                                          'under
	END IF                                                       'an
								 'angle
	IF yi > xi THEN                                              'other wise
	    add2x = xi / yi                                          'the
	    add2y = 1                                                'plotter
	END IF                                                       'would
								 'draw
	IF yi = xi THEN                                              'lines
	    add2x = 1                                                'other
	    add2y = 1                                                'then straight
	END IF                                                       'or 45 degree
								 'lines wrong


 IF xnew > xold THEN xdirection = 4 ELSE xdirection = 0  'data 6 -> pin 7
 IF ynew < yold THEN ydirection = 16 ELSE ydirection = 0  'data 7 -> pin 8



 IF xnew = xold THEN xdirection = oldxdirection
 IF ynew = yold THEN ydirection = oldydirection

 oldxdirection = xdirection
 oldydirection = ydirection


acceleratie = minaccxy                       'stepdelay


stap:
 
 

  IF CINT(u) < x THEN u = u + add2x
  IF CINT(u) > x THEN u = u - add2x
  IF CINT(v) < Y THEN v = v + add2y
  IF CINT(v) > Y THEN v = v - add2y

ValeuX = CINT(u) MOD 8          'used for uln2803 & 5804
ValeuY = CINT(v) MOD 8          'see next lines why for 5804
	
IF ValeuX <> StoreValeuX THEN stepx = 8 ELSE stepx = 0      'data 1 -> pin 2
IF ValeuY <> StoreValeuY THEN stepy = 32 ELSE stepy = 0      'data 2 -> pin 3

StoreValeuX = ValeuX
StoreValeuY = ValeuY
	      
       

	   OUT (&H378), (xdirection + stepx + ydirection + stepy)
	   FOR t = 1 TO 1: NEXT t
	   OUT (&H378), (xdirection + ydirection)
       


	  xi = xi - add2x
	  yi = yi - add2y

	  IF xi > yi THEN
		IF xi < maxaccxy THEN acceleratie = acceleratie + 2.5
	ELSE IF yi < maxaccxy THEN acceleratie = acceleratie + 2.5
	END IF
       
	 IF acceleratie > minaccxy THEN acceleratie = minaccxy
	 IF acceleratie < maxaccxy THEN acceleratie = maxaccxy
       
	 FOR N = 1 TO acceleratie: NEXT N
	 acceleratie = acceleratie - 1.5
	
	 IF xnew <> CINT(u) OR ynew <> CINT(v) THEN GOTO stap
	
	 xold = x
	 yold = Y


	LOOP

	 OUT (&H378), 0
	 OUT (&H378 + 2), 0 XOR 11

	
	FFRESA = 0
	CLOSE
	
	DO WHILE INKEY$ = ""
	LOOP
	SCREEN 0


	RETURN
'---------------------------------------------------------

'--------------------------------------------------------------------

sU:
			stepz = 128
			zdirection = 0
	 
	  ICONTA = 0
	  IAVANTIA = IAVANTI / 2
	  IF IAVANTIA < 1 THEN IAVANTIA = 1
	  IAVANTIM = IAVANTI - IAVANTIA
	  IF IAVANTIM > IACELD THEN
		IAVANTIF = IACELD
		IAVANTIM = IAVANTI - IAVANTIA - IACELD
	  ELSE
		IAVANTIF = IAVANTI - IAVANTIA
		IAVANTIM = 0
	  END IF
      
       
	  IGA = IACELD
	  FOR ID = 1 TO IAVANTIA
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA - 1
		IF IGA < IMAXVELD THEN IGA = IMAXVELD
			      OUT (&H378), (stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), 0
			      FOR t = 1 TO 1: NEXT t
	       
		ICONTA = ICONTA + 1
	  NEXT ID

     
	  FOR ID = 1 TO IAVANTIM
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA - 1
		IF IGA < IMAXVELD THEN IGA = IMAXVELD
			      OUT (&H378), (stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), 0
			      FOR t = 1 TO 1: NEXT t
	       
		ICONTA = ICONTA + 1
	  NEXT ID
    
    
	  FOR ID = 1 TO IAVANTIF
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA + 1
		IF IGA > IACELD THEN IGA = IACELD
			      OUT (&H378), (stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), 0
			      FOR t = 1 TO 1: NEXT t
	       
		ICONTA = ICONTA + 1
	  NEXT ID
    
	  PRINT "SU     = "; ICONTA
       
RETURN


giu:
			stepz = 128
			zdirection = 64

       
	  ICONTA = 0
	  IAVANTIA = IAVANTI / 2
	  IF IAVANTIA < 1 THEN IAVANTIA = 1
	  IAVANTIM = IAVANTI - IAVANTIA
	  IF IAVANTIM > IACELD THEN
		IAVANTIF = IACELD
		IAVANTIM = IAVANTI - IAVANTIA - IACELD
	  ELSE
		IAVANTIF = IAVANTI - IAVANTIA
		IAVANTIM = 0
	  END IF
     
      
	  IGA = IACELD
	  FOR ID = 1 TO IAVANTIA
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA - 1
		IF IGA < IMAXVELD THEN IGA = IMAXVELD
			      OUT (&H378), (zdirection + stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), zdirection
	       
		ICONTA = ICONTA + 1
	  NEXT ID

    
	  FOR ID = 1 TO IAVANTIM
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA - 1
		IF IGA < IMAXVELD THEN IGA = IMAXVELD
			      OUT (&H378), (zdirection + stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), zdirection
	       
		ICONTA = ICONTA + 1
	  NEXT ID
   
   
	  FOR ID = 1 TO IAVANTIF
		FOR IG = 1 TO IGA: NEXT IG
		IGA = IGA + 1
		IF IGA > IACELD THEN IGA = IACELD
			      OUT (&H378), (zdirection + stepz)
			      FOR t = 1 TO 1: NEXT t
			      OUT (&H378), zdirection
	       
		ICONTA = ICONTA + 1
	  NEXT ID
   
	  PRINT "GIU    = "; ICONTA
    
RETURN



